## zeroinstall-injector 2.10

=== Makefile ===
# When building with 0compile, these will get overridden.
# The defaults are the same as when building with 0compile in-place (e.g.
# in a Git checkout), so you don't need 0compile to build 0install, which
# would create a bootstapping problem.
SRCDIR = $(abspath .)
DISTDIR = $(abspath dist)
BUILDDIR = $(abspath build)

SH = ${SRCDIR}/share/0install.net/unlzma

# There are several things you might want to do:
#
# 1. a traditional install (e.g. under /usr/local or ~)
# 2. build a library for other 0install tools (e.g. 0compile)
# 3. for testing, in place (during development)
#
# New users and distribution packagers will want to do (1).
#
# When you do a plain "make":
#
# a) $DISTDIR ends up with a complete distribution suitable for publishing or
#    registering with 0install. $DISTDIR contains:
#    - Python source code
#    - Cross-platform OCaml bytecode
#    - A 0install binary feed, which can be registered with "0install add"
#
# b) A native "0install" executable is created in $BUILDDIR, but is not copied
#    to $DISTDIR (since it's not portable).
#
# To install as a normal package:	make && sudo make install
# To test without installing:     	make && ./dist/bin/0install
# To use as a library with other tools: 0compile build && 0compile register
# To publish a release on 0install.net: use 0release
# To make a generic build/static_dist:  make static_dist
#
# Running plain "make" does most of the same things that "0compile build" would do,
# except that it doesn't generate/update the binary feed (dist/0install/feed.xml).

default: all

# Ubuntu's make requires this to come before the %:: default rule.
%.ui.h: %.ui
	intltool-extract --type=gettext/glade --update "$<"

%.html: %.md
	redcarpet $< > $@ || (rm -f $@; false)

# Make needs to run from the build directory, but people always want to run it from
# the source directory. This rule matches all targets not defined here (i.e. those
# which operate on the build directory) and runs make again from the build directory,
# with Makefile.build.
%::
	[ -d "${BUILDDIR}" ] || mkdir "${BUILDDIR}"
	[ -d "${DISTDIR}" ] || mkdir "${DISTDIR}"
	$(MAKE) -C "${BUILDDIR}" -f "${SRCDIR}/Makefile.build" "$@" SRCDIR="${SRCDIR}" BUILDDIR="${BUILDDIR}" DISTDIR="${DISTDIR}" DESTDIR="${DESTDIR}"

share/locale/zero-install.pot: $(SH)
	xgettext --sort-by-file --language=Shell -j --output=$@ $(SH)

update-po: share/locale/zero-install.pot
	@for po in share/locale/*/LC_MESSAGES/zero-install.po; do \
	    echo -e "Merge: $$po: \c"; \
	    msgmerge -v -U $$po share/locale/zero-install.pot; \
	done

check-po:
	@for po in share/locale/*/LC_MESSAGES/zero-install.po; do \
	    echo -e "Check: $$po: \c"; \
	    msgfmt -o /dev/null --statistics -v -c $$po; \
	done

clean:
	rm -rf build
	rm -rf dist

.PHONY: update-po check-po clean default

=== ocaml/Makefile ===
OCAML_BUILDDIR=../build/ocaml
TYPE=native
OCAMLBUILD=ocamlbuild -j 0 -build-dir "${OCAML_BUILDDIR}"
ifeq ($(OS), Windows_NT)
  WINDOWS_LIBS = $(shell dirname $(shell which ocamlc))
  OCAMLBUILDFLAGS = -lflag -cclib -lflag -lshell32
endif
TEST_BINARY=${OCAML_BUILDDIR}/tests/test.$(TYPE)
# Windows only: Set WINDRES, if it is neither called i686-w64-mingw32-windres.exe (i686)
# nor x86_64-w64-mingw32-windres.exe (x86_64).
# WINDRES=i686-w64-windres
# export WINDRES

.PHONY: all ocaml doc clean tags test

all: build_dir ocaml test

build_dir:
	[ -d "${OCAML_BUILDDIR}" ] || mkdir -p "${OCAML_BUILDDIR}"

test: ocaml
	@if [ -f "${TEST_BINARY}" ]; then "${TEST_BINARY}"; else echo "Unit-tests not compiled, so skipping tests"; fi

# Build static version (of $TYPE)
ocaml: build_dir
	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) "all-${TYPE}.otarget"
	#cp 0install.ml "$(OCAML_BUILDDIR)/"
	if [ "$(OS)" = "Windows_NT" ];then $(MAKE) ocaml_windows; else $(MAKE) ocaml_posix; fi

# For static Windows version, we also need the runenv.native helper.
ocaml_windows:
	cp ${OCAML_BUILDDIR}/static_0install.$(TYPE) ${OCAML_BUILDDIR}/0install.exe
	cp ${OCAML_BUILDDIR}/runenv.native ${OCAML_BUILDDIR}/0install-runenv.exe
	ln -f "${OCAML_BUILDDIR}/0install.exe" "${OCAML_BUILDDIR}/0launch.exe"
	cp "${WINDOWS_LIBS}/libeay32.dll" "${WINDOWS_LIBS}/ssleay32.dll" "${OCAML_BUILDDIR}"

ocaml_posix:
	cp ${OCAML_BUILDDIR}/static_0install.$(TYPE) ${OCAML_BUILDDIR}/0install
	-[ -L 0install ] || ln -s ../build/ocaml/0install 0install
	@# so Vim can find the type annotations:
	-[ -L _build -o -e _build ] || ln -s ${OCAML_BUILDDIR} _build
	ln -f "${OCAML_BUILDDIR}/0install" "${OCAML_BUILDDIR}/0launch"

doc:
	ocp-pack -o support.ml.tmp support/logging.ml support/common.ml support/utils.ml support/basedir.ml support/qdom.ml support/system.ml
	echo '(** General support code; not 0install-specific *)' > support.ml
	cat support.ml.tmp >> support.ml
	rm support.ml.tmp
	$(OCAMLBUILD) 0install.docdir/index.html
	rm support.ml

# Results turn up in the "html" directory after running the unit-tests.
coverage:
	rm -f bisect*.out
	OCAML_COVERAGE=true make test
	ocaml-bisect-report -I "${OCAML_BUILDDIR}" -html html "bisect0001.out"

clean:
	mkdir -p ${OCAML_BUILDDIR}
	$(OCAMLBUILD) -clean

tags:
	ctags -R [a-z]*

=== debian/changelog ===
zeroinstall-injector (2.10-2) unstable; urgency=medium

  * Conflict with 0install-core < 2.10 to avoid upgrade failure.
    Fixes #805283.

 -- Thomas Leonard <talex5@gmail.com>  Mon, 16 Nov 2015 11:49:40 +0000

zeroinstall-injector (2.10-1) unstable; urgency=medium

  * New upstream release. Closes: #804431 (build failure).
  * Moved .desktop file from 0install-core to 0install, as it requires
    the GUI.

 -- Thomas Leonard <talex5@gmail.com>  Fri, 13 Nov 2015 09:45:10 +0000

=== debian/control ===
Source: zeroinstall-injector
Section: admin
Priority: extra
Maintainer: Thomas Leonard <talex5@gmail.com>
Build-Depends: debhelper (>= 9), ocaml-nox, dh-ocaml, ocaml-findlib, libyojson-ocaml-dev, libxmlm-ocaml-dev, camlp4-extra, gettext, liblwt-ocaml-dev, libounit-ocaml-dev, libextlib-ocaml-dev, libcurl-ocaml-dev, libssl-ocaml-dev, libobus-ocaml-dev, liblablgtk2-ocaml-dev, liblwt-glib-ocaml-dev, unzip, binutils
Standards-Version: 3.9.6
Homepage: http://0install.net/
Vcs-Browser: https://github.com/0install/0install-debian
Vcs-Git: https://github.com/0install/0install-debian.git

Package: 0install
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, 0install-core (>= ${source:Version}), libgtk2.0-0
Replaces: 0install-core (<< 2.10-1)
Breaks: 0install-core (<< 2.10-1)
Description: cross-distribution packaging system
 Zero Install is a decentralised cross-distribution software installation
 system available under the LGPL. It allows software developers to publish
 programs directly from their own web-sites, while supporting features familiar
 from centralised distribution repositories such as shared libraries, automatic
 updates and digital signatures. It is intended to complement, rather than
 replace, the operating system's package management. 0install packages never
 interfere with those provided by the distribution.
 .
 This package includes the GTK GUI for 0install. If you have a headless system,
 install just the 0install-core package to avoid pulling in any GUI
 dependencies.

Package: 0install-core
Architecture: any
Depends: ${misc:Depends}, gnupg, bzip2, adduser, xdg-utils, ca-certificates, ${shlibs:Depends}
Recommends: unzip, lzma, packagekit | python3-aptdaemon.pkcompat
Suggests: cabextract, rpm2cpio, 0install
Provides: zeroinstall-injector
Replaces: zeroinstall-injector (<< 2.3.3-2)
Breaks: zeroinstall-injector (<< 2.3.3-2)
Description: cross-distribution packaging system (non-GUI parts)
 Zero Install is a decentralised cross-distribution software installation
 system available under the LGPL. It allows software developers to publish
 programs directly from their own web-sites, while supporting features familiar
 from centralised distribution repositories such as shared libraries, automatic
 updates and digital signatures. It is intended to complement, rather than
 replace, the operating system's package management. 0install packages never
 interfere with those provided by the distribution.

Package: zeroinstall-injector
Architecture: all
Section: oldlibs
Pre-Depends: dpkg (>= 1.17.5)
Depends: ${misc:Depends}, 0install, 0install-core
Description: transitional package for 0install
 This is a transitional package for 0install, and can be safely removed
 after the installation is complete.
 .
 Note: If you have a headless system, install just the 0install-core package to
 avoid pulling in any GUI dependencies.

=== debian/rules ===
#!/usr/bin/make -f

OCAMLABI := $(shell ocamlc -version)

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	rm -rf $(CURDIR)/build
	dh_clean 

build: build-arch
build-indep:
build-arch: build-stamp

build-stamp:
	dh_testdir
	if [ -x /usr/bin/ocamlopt ]; then \
		make -C $(CURDIR) TYPE=native; \
	else \
		make -C $(CURDIR) TYPE=byte; \
	fi
	touch $@

install: build-stamp
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(CURDIR)/dist/install.sh $(CURDIR)/debian/0install-core/usr
	mkdir -p $(CURDIR)/debian/0install/usr/lib/0install.net
	mkdir -p $(CURDIR)/debian/0install/usr/share/applications
	mv $(CURDIR)/debian/0install-core/usr/lib/0install.net/gui_gtk.* $(CURDIR)/debian/0install/usr/lib/0install.net/
	mv $(CURDIR)/debian/0install-core/usr/share/applications/0install.desktop $(CURDIR)/debian/0install/usr/share/applications/
	rmdir $(CURDIR)/debian/0install-core/usr/lib/0install.net
	rmdir $(CURDIR)/debian/0install-core/usr/lib
	mv $(CURDIR)/debian/0install-core/usr/share/zsh/site-functions $(CURDIR)/debian/0install-core/usr/share/zsh/vendor-completions
	rm -r $(CURDIR)/debian/0install-core/usr/share/doc/0install
	if [ -x /usr/bin/ocamlopt ]; then \
		dh_strip; dh_shlibdeps; \
	fi

binary-arch: build-stamp install
	dh_testdir
	dh_testroot
	dh_installchangelogs -p 0install-core
	dh_installdocs -a --link-doc=0install-core
	dh_installman -a
	dh_compress -a
	dh_fixperms -a
	#dh_ocaml		(not for -custom bytecode)
	dh_installdeb -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary-indep:
	dh_testdir
	dh_testroot
	dh_installdocs -i --link-doc=0install-core
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary: binary-indep binary-arch

.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
version=3
opts="pgpsigurlmangle=s/$/.sig/" http://sf.net/zero-install/0install-(\d.+)\.tar\.bz2

## zeroinstall-injector 2.12

=== ocaml/Makefile ===
--- 
+++ 
@@ -1,6 +1,13 @@
 OCAML_BUILDDIR=../build/ocaml
+
+ifeq ($(shell uname -o),Cygwin)
+  BUILDDIR_NATIVE = $(shell cygpath -w ${OCAML_BUILDDIR})
+else
+  BUILDDIR_NATIVE = ${OCAML_BUILDDIR}
+endif
+
 TYPE=native
-OCAMLBUILD=ocamlbuild -j 0 -build-dir "${OCAML_BUILDDIR}"
+OCAMLBUILD=ocamlbuild -j 0 -build-dir "${BUILDDIR_NATIVE}"
 ifeq ($(OS), Windows_NT)
   WINDOWS_LIBS = $(shell dirname $(shell which ocamlc))
   OCAMLBUILDFLAGS = -lflag -cclib -lflag -lshell32

=== debian/changelog ===
zeroinstall-injector (2.12-4) unstable; urgency=medium

  * Replace openssl with ocaml-sha for hash functions.
    This fixes a build problem on Ubuntu.

 -- Thomas Leonard <talex5@gmail.com>  Tue, 21 Mar 2017 07:54:00 +0000

zeroinstall-injector (2.12-3) unstable; urgency=medium

  * Don't recommend python3-aptdaemon.pkcompat. Closes: #848559.

 -- Thomas Leonard <talex5@gmail.com>  Sun, 19 Mar 2017 09:28:46 +0000

zeroinstall-injector (2.12-2) unstable; urgency=medium

  * Add missing build dep on tzdata. Closes: #839511.

 -- Thomas Leonard <talex5@gmail.com>  Sun, 02 Oct 2016 12:53:59 +0000

zeroinstall-injector (2.12-1) unstable; urgency=medium

  * New upstream release.
  * Add missing build dep. Closes: #837226.

 -- Thomas Leonard <talex5@gmail.com>  Sun, 25 Sep 2016 07:55:43 +0000

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: admin
 Priority: extra
 Maintainer: Thomas Leonard <talex5@gmail.com>
-Build-Depends: debhelper (>= 9), ocaml-nox, dh-ocaml, ocaml-findlib, libyojson-ocaml-dev, libxmlm-ocaml-dev, camlp4-extra, gettext, liblwt-ocaml-dev, libounit-ocaml-dev, libextlib-ocaml-dev, libcurl-ocaml-dev, libssl-ocaml-dev, libobus-ocaml-dev, liblablgtk2-ocaml-dev, liblwt-glib-ocaml-dev, unzip, binutils
-Standards-Version: 3.9.6
+Build-Depends: debhelper (>= 9), ocaml-nox, dh-ocaml, ocaml-findlib, libyojson-ocaml-dev, libxmlm-ocaml-dev, camlp4-extra, gettext, liblwt-ocaml-dev, libounit-ocaml-dev, libextlib-ocaml-dev, libcurl-ocaml-dev, libsha-ocaml-dev, libobus-ocaml-dev, liblablgtk2-ocaml-dev, liblwt-glib-ocaml-dev, unzip, binutils, gnupg, tzdata
+Standards-Version: 3.9.8
 Homepage: http://0install.net/
 Vcs-Browser: https://github.com/0install/0install-debian
 Vcs-Git: https://github.com/0install/0install-debian.git
@@ -29,7 +29,7 @@
 Package: 0install-core
 Architecture: any
 Depends: ${misc:Depends}, gnupg, bzip2, adduser, xdg-utils, ca-certificates, ${shlibs:Depends}
-Recommends: unzip, lzma, packagekit | python3-aptdaemon.pkcompat
+Recommends: unzip, lzma, packagekit
 Suggests: cabextract, rpm2cpio, 0install
 Provides: zeroinstall-injector
 Replaces: zeroinstall-injector (<< 2.3.3-2)

## zeroinstall-injector 2.12.3

=== Makefile ===
--- 
+++ 
@@ -36,7 +36,7 @@
 # Running plain "make" does most of the same things that "0compile build" would do,
 # except that it doesn't generate/update the binary feed (dist/0install/feed.xml).
 
-default: all
+default: all test
 
 # Ubuntu's make requires this to come before the %:: default rule.
 %.ui.h: %.ui

=== ocaml/Makefile ===
--- 
+++ 
@@ -7,9 +7,9 @@
 endif
 
 TYPE=native
-OCAMLBUILD=ocamlbuild -j 0 -build-dir "${BUILDDIR_NATIVE}"
+OCAMLBUILD=ocamlbuild -j 0 -use-ocamlfind -plugin-tag 'package(cppo_ocamlbuild)' -build-dir "${BUILDDIR_NATIVE}"
+WINDOWS_LIBS = $(shell dirname $(shell which ocamlc))
 ifeq ($(OS), Windows_NT)
-  WINDOWS_LIBS = $(shell dirname $(shell which ocamlc))
   OCAMLBUILDFLAGS = -lflag -cclib -lflag -lshell32
 endif
 TEST_BINARY=${OCAML_BUILDDIR}/tests/test.$(TYPE)
@@ -31,15 +31,14 @@
 # Build static version (of $TYPE)
 ocaml: build_dir
 	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) "all-${TYPE}.otarget"
-	#cp 0install.ml "$(OCAML_BUILDDIR)/"
-	if [ "$(OS)" = "Windows_NT" ];then $(MAKE) ocaml_windows; else $(MAKE) ocaml_posix; fi
+	if [ -f "${OCAML_BUILDDIR}/runenv.native" ];then $(MAKE) ocaml_windows; else $(MAKE) ocaml_posix; fi
 
 # For static Windows version, we also need the runenv.native helper.
 ocaml_windows:
 	cp ${OCAML_BUILDDIR}/static_0install.$(TYPE) ${OCAML_BUILDDIR}/0install.exe
 	cp ${OCAML_BUILDDIR}/runenv.native ${OCAML_BUILDDIR}/0install-runenv.exe
 	ln -f "${OCAML_BUILDDIR}/0install.exe" "${OCAML_BUILDDIR}/0launch.exe"
-	cp "${WINDOWS_LIBS}/libeay32.dll" "${WINDOWS_LIBS}/ssleay32.dll" "${OCAML_BUILDDIR}"
+	-cp "${WINDOWS_LIBS}/libeay32.dll" "${WINDOWS_LIBS}/ssleay32.dll" "${OCAML_BUILDDIR}"
 
 ocaml_posix:
 	cp ${OCAML_BUILDDIR}/static_0install.$(TYPE) ${OCAML_BUILDDIR}/0install

=== debian/changelog ===
zeroinstall-injector (2.12.3-2) unstable; urgency=high

  * Backport fix for case-sensitive HTTP header check. Closes: #927873.

 -- Thomas Leonard <talex5@gmail.com>  Wed, 24 Apr 2019 11:05:04 +0000

zeroinstall-injector (2.12.3-1) unstable; urgency=medium

  * New upstream release.

 -- Thomas Leonard <talex5@gmail.com>  Sun, 19 Nov 2017 15:55:15 +0000

zeroinstall-injector (2.12.2-4) unstable; urgency=medium

  * Disable tests on byte-code platforms.
    They're not currently working due to the OCaml 4.05 transition.

 -- Thomas Leonard <talex5@gmail.com>  Sun, 29 Oct 2017 09:20:39 +0000

zeroinstall-injector (2.12.2-3) unstable; urgency=medium

  * Fix building the byte-code version.

 -- Thomas Leonard <talex5@gmail.com>  Sun, 22 Oct 2017 14:15:56 +0000

zeroinstall-injector (2.12.2-2) unstable; urgency=medium

  * Remove work-around for old versions of Lwt.
  * Remove transitional zeroinstall-injector package. Closes: #878993.

 -- Thomas Leonard <talex5@gmail.com>  Sat, 21 Oct 2017 10:21:44 +0000

zeroinstall-injector (2.12.2-1) unstable; urgency=medium

  * New upstream release. Closes: #870151.

 -- Thomas Leonard <talex5@gmail.com>  Sun, 06 Aug 2017 18:06:06 +0000

zeroinstall-injector (2.12-5) unstable; urgency=medium

  * Add build-depends on ocamlbuild. Closes: #870037.

 -- Thomas Leonard <talex5@gmail.com>  Sun, 30 Jul 2017 09:15:07 +0000

=== debian/control ===
Source: zeroinstall-injector
Section: admin
Priority: optional
Maintainer: Thomas Leonard <talex5@gmail.com>
Build-Depends: binutils,
               cppo,
               debhelper (>= 9),
               dh-ocaml,
               gettext,
               gnupg,
               libcurl-ocaml-dev,
               liblablgtk2-ocaml-dev,
               liblwt-glib-ocaml-dev,
               liblwt-ocaml-dev (>= 2.7.0),
               libobus-ocaml-dev,
               libounit-ocaml-dev,
               libsha-ocaml-dev,
               libxmlm-ocaml-dev,
               libyojson-ocaml-dev,
               ocamlbuild,
               ocaml-findlib,
               ocaml-nox,
               tzdata,
               unzip
Standards-Version: 4.1.1
Homepage: http://0install.net/
Vcs-Browser: https://github.com/0install/0install-debian
Vcs-Git: https://github.com/0install/0install-debian.git

Package: 0install
Architecture: any
Depends: 0install-core (>= ${source:Version}),
         libgtk2.0-0,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: 0install-core (<< 2.10-1)
Breaks: 0install-core (<< 2.10-1)
Description: cross-distribution packaging system
 Zero Install is a decentralised cross-distribution software installation
 system available under the LGPL. It allows software developers to publish
 programs directly from their own web-sites, while supporting features familiar
 from centralised distribution repositories such as shared libraries, automatic
 updates and digital signatures. It is intended to complement, rather than
 replace, the operating system's package management. 0install packages never
 interfere with those provided by the distribution.
 .
 This package includes the GTK GUI for 0install. If you have a headless system,
 install just the 0install-core package to avoid pulling in any GUI
 dependencies.

Package: 0install-core
Architecture: any
Depends: adduser,
         bzip2,
         ca-certificates,
         gnupg,
         xdg-utils,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: lzma, packagekit, unzip
Suggests: 0install, cabextract, rpm2cpio
Provides: zeroinstall-injector
Replaces: zeroinstall-injector (<< 2.3.3-2)
Breaks: zeroinstall-injector (<< 2.3.3-2)
Description: cross-distribution packaging system (non-GUI parts)
 Zero Install is a decentralised cross-distribution software installation
 system available under the LGPL. It allows software developers to publish
 programs directly from their own web-sites, while supporting features familiar
 from centralised distribution repositories such as shared libraries, automatic
 updates and digital signatures. It is intended to complement, rather than
 replace, the operating system's package management. 0install packages never
 interfere with those provided by the distribution.

## zeroinstall-injector 2.14.1

=== Makefile ===
# When building with 0compile, these will get overridden.
SRCDIR = $(abspath .)
DISTDIR = $(abspath dist)

# Using PROFILE=dev makes warnings fatal and makes the build faster by doing fewer optimisations
PROFILE ?= release

# There are several things you might want to do:
#
# 1. a traditional install (e.g. under /usr/local or ~)
# 2. build a library for other 0install tools (e.g. 0compile)
# 3. for testing, in place (during development)
#
# New users and distribution packagers will want to do (1).
#
# When you do a plain "make", $DISTDIR ends up with a complete distribution
# suitable for publishing or registering with 0install. $DISTDIR contains:
#
# - The compiled binaries
# - A 0install binary feed, which can be registered with "0install add"
#
# To install as a normal package:	make && sudo make install
# To test without installing:     	make && ./dist/bin/0install
# To use as a library with other tools: 0compile build && 0compile register
# To publish a release on 0install.net: use 0release

default: all test

%.html: %.md
	redcarpet $< > $@ || (rm -f $@; false)

clean:
	dune clean --root=. --profile=${PROFILE}
	rm -rf build dist

DOCS = README.md COPYING
MANPAGES = 0launch.1 0store-secure-add.1 0store.1 0desktop.1 0install.1

OS = $(shell uname -s)
MACHINE = $(shell uname -m)
VERSION = $(shell sed -n 's/let version = "\(.*\)"/\1/p' ${SRCDIR}/ocaml/zeroinstall/about.ml)

all:
	dune build --root=. --profile=${PROFILE} @install
	install -d "${DISTDIR}"
	install -d "${DISTDIR}/files"
	install -d "${DISTDIR}/files/gui_gtk"
	install -d "${DISTDIR}/files/share"
	(cd "${SRCDIR}" && cp ${DOCS} "${DISTDIR}/")
	-install _build/install/default/lib/0install/gui_gtk.cma "${DISTDIR}/files/gui_gtk/"
	-install _build/install/default/lib/0install/gui_gtk.cmxs "${DISTDIR}/files/gui_gtk/"
	install _build/install/default/bin/0install "${DISTDIR}/files/0install"
	ln -f "${DISTDIR}/files/0install" "${DISTDIR}/files/0launch"
	ln -f "${DISTDIR}/files/0install" "${DISTDIR}/files/0store"
	ln -f "${DISTDIR}/files/0install" "${DISTDIR}/files/0store-secure-add"
	ln -f "${DISTDIR}/files/0install" "${DISTDIR}/files/0desktop"
	ln -f "${DISTDIR}/files/0install" "${DISTDIR}/files/0alias"
	(cd "${SRCDIR}/ocaml" && cp ${MANPAGES} "${DISTDIR}/files")
	install "${SRCDIR}/install.sh.src" "${DISTDIR}/install.sh"
	(cd "${SRCDIR}" && cp -r share/0install.net share/applications share/metainfo share/bash-completion share/fish share/icons share/zsh "${DISTDIR}/files/share/")
	install -d "${DISTDIR}/0install"
	[ -f "${DISTDIR}/0install/build-environment.xml" ] || sed 's/@ARCH@/${OS}-${MACHINE}/;s/@VERSION@/${VERSION}/' "${SRCDIR}/binary-feed.xml.in" > "${DISTDIR}/0install/feed.xml"

test:
	dune runtest --root=. --profile=${PROFILE}

doc:
	dune build --root=. --profile=${PROFILE} @doc

install: install_local

install_home:
	(cd "${DISTDIR}" && ./install.sh home)

install_system:
	(cd "${DISTDIR}" && ./install.sh system)

install_local:
	(cd "${DISTDIR}" && ./install.sh local)

.PHONY: all install test

.PHONY: clean default

=== debian/changelog ===
zeroinstall-injector (2.14.1-3) unstable; urgency=medium

  * Fix link error on MIPS.
    This is fixed upstream in Lwt 3.1.0.

 -- Thomas Leonard <talex5@gmail.com>  Sun, 01 Sep 2019 14:41:02 +0000

zeroinstall-injector (2.14.1-2) unstable; urgency=medium

  * Fix camlp4 on MIPS.

 -- Thomas Leonard <talex5@gmail.com>  Sat, 31 Aug 2019 10:49:24 +0000

zeroinstall-injector (2.14.1-1) unstable; urgency=high

  * New upstream release.
  * Urgent because the package got suddenly removed from testing,
    due to removal of the obus package it depends on.
  * Closes: #934340.

 -- Thomas Leonard <talex5@gmail.com>  Sat, 24 Aug 2019 14:01:32 +0000

=== debian/control ===
--- 
+++ 
@@ -10,19 +10,18 @@
                gnupg,
                libcurl-ocaml-dev,
                liblablgtk2-ocaml-dev,
-               liblwt-glib-ocaml-dev,
                liblwt-ocaml-dev (>= 2.7.0),
-               libobus-ocaml-dev,
                libounit-ocaml-dev,
                libsha-ocaml-dev,
                libxmlm-ocaml-dev,
                libyojson-ocaml-dev,
-               ocamlbuild,
+               ocaml-dune,
                ocaml-findlib,
                ocaml-nox,
+               ocamlbuild,
                tzdata,
                unzip
-Standards-Version: 4.1.1
+Standards-Version: 4.4.0
 Homepage: http://0install.net/
 Vcs-Browser: https://github.com/0install/0install-debian
 Vcs-Git: https://github.com/0install/0install-debian.git

=== debian/rules ===
--- 
+++ 
@@ -13,13 +13,19 @@
 build-indep:
 build-arch: build-stamp
 
+VENDOR := /tmp/0install-build-vendor
+OCAMLPATH := $(VENDOR)/usr/lib/ocaml
+PATH := $(VENDOR)/usr/bin:$(PATH)
+
 build-stamp:
 	dh_testdir
+	(cd vendor && ./fix-debian.sh) && rm -rf vendor
 	if [ -x /usr/bin/ocamlopt ]; then \
-		make -C $(CURDIR) TYPE=native; \
+		make OCAMLPATH=$(OCAMLPATH) TYPE=native; \
 	else \
-		make -C $(CURDIR) TYPE=byte; \
+		make OCAMLPATH=$(OCAMLPATH) all TYPE=byte; \
 	fi
+	rm -rf /tmp/0install-build-vendor
 	touch $@
 
 install: build-stamp

## zeroinstall-injector 2.15

=== debian/changelog ===
zeroinstall-injector (2.15-1) unstable; urgency=medium

  * New upstream release.

 -- Thomas Leonard <talex5@gmail.com>  Wed, 18 Dec 2019 14:51:21 +0000

## zeroinstall-injector 2.15.1

=== Makefile ===
--- 
+++ 
@@ -31,7 +31,7 @@
 
 clean:
 	dune clean --root=. --profile=${PROFILE}
-	rm -rf build dist
+	rm -rf build dist static/dist.tgz
 
 DOCS = README.md COPYING
 MANPAGES = 0launch.1 0store-secure-add.1 0store.1 0desktop.1 0install.1
@@ -81,3 +81,15 @@
 .PHONY: all install test
 
 .PHONY: clean default
+
+.PHONY: static-test
+
+static/dist.tgz: static/Dockerfile
+	docker build -t talex5/0install-static-build -f static/Dockerfile .
+	docker run talex5/0install-static-build tar czf - dist > static/dist.tgz
+
+static-test-%: static/Dockerfile-test-% static/dist.tgz
+	docker build -f $< ./static -t 0install-test
+	docker run --rm -it -v "${SRCDIR}/static:/mnt:ro" 0install-test /mnt/run-tests.sh
+
+static-test: static-test-debian-10 static-test-fedora-30

=== debian/changelog ===
zeroinstall-injector (2.15.1-1) unstable; urgency=medium

  * New upstream release.

 -- Thomas Leonard <talex5@gmail.com>  Sun, 23 Feb 2020 14:44:47 +0000

=== debian/control ===
--- 
+++ 
@@ -15,6 +15,9 @@
                libsha-ocaml-dev,
                libxmlm-ocaml-dev,
                libyojson-ocaml-dev,
+               libppxlib-ocaml-dev,
+               liblwt-log-ocaml-dev,
+               menhir,
                ocaml-dune,
                ocaml-findlib,
                ocaml-nox,

=== debian/rules ===
--- 
+++ 
@@ -14,12 +14,11 @@
 build-arch: build-stamp
 
 VENDOR := /tmp/0install-build-vendor
-OCAMLPATH := $(VENDOR)/usr/lib/ocaml
-PATH := $(VENDOR)/usr/bin:$(PATH)
+OCAMLPATH := $(VENDOR)/lib
 
 build-stamp:
 	dh_testdir
-	(cd vendor && ./fix-debian.sh) && rm -rf vendor
+	mv vendor/lwt_glib-1.1.1 . && dune build @lwt_glib-1.1.1/install && dune install --prefix=$(VENDOR) lwt_glib && rm -rf lwt_glib-1.1.1
 	if [ -x /usr/bin/ocamlopt ]; then \
 		make OCAMLPATH=$(OCAMLPATH) TYPE=native; \
 	else \

## zeroinstall-injector 2.16

=== Makefile ===
--- 
+++ 
@@ -38,7 +38,7 @@
 
 OS = $(shell uname -s)
 MACHINE = $(shell uname -m)
-VERSION = $(shell sed -n 's/let version = "\(.*\)"/\1/p' ${SRCDIR}/ocaml/zeroinstall/about.ml)
+VERSION = $(shell sed -n 's/let version = "\(.*\)"/\1/p' ${SRCDIR}/src/zeroinstall/about.ml)
 
 all:
 	dune build --root=. --profile=${PROFILE} @install
@@ -47,15 +47,15 @@
 	install -d "${DISTDIR}/files/gui_gtk"
 	install -d "${DISTDIR}/files/share"
 	(cd "${SRCDIR}" && cp ${DOCS} "${DISTDIR}/")
-	-install _build/install/default/lib/0install/gui_gtk.cma "${DISTDIR}/files/gui_gtk/"
-	-install _build/install/default/lib/0install/gui_gtk.cmxs "${DISTDIR}/files/gui_gtk/"
+	-install _build/install/default/lib/0install-gtk/gui_gtk.cma "${DISTDIR}/files/gui_gtk/"
+	-install _build/install/default/lib/0install-gtk/gui_gtk.cmxs "${DISTDIR}/files/gui_gtk/"
 	install _build/install/default/bin/0install "${DISTDIR}/files/0install"
 	ln -f "${DISTDIR}/files/0install" "${DISTDIR}/files/0launch"
 	ln -f "${DISTDIR}/files/0install" "${DISTDIR}/files/0store"
 	ln -f "${DISTDIR}/files/0install" "${DISTDIR}/files/0store-secure-add"
 	ln -f "${DISTDIR}/files/0install" "${DISTDIR}/files/0desktop"
 	ln -f "${DISTDIR}/files/0install" "${DISTDIR}/files/0alias"
-	(cd "${SRCDIR}/ocaml" && cp ${MANPAGES} "${DISTDIR}/files")
+	(cd "${SRCDIR}/src" && cp ${MANPAGES} "${DISTDIR}/files")
 	install "${SRCDIR}/install.sh.src" "${DISTDIR}/install.sh"
 	(cd "${SRCDIR}" && cp -r share/0install.net share/applications share/metainfo share/bash-completion share/fish share/icons share/zsh "${DISTDIR}/files/share/")
 	install -d "${DISTDIR}/0install"

=== vendor/lwt_glib-1.1.1/Makefile ===
.PHONY : build
build :
	dune build

.PHONY : clean
clean :
	dune clean

=== debian/changelog ===
zeroinstall-injector (2.16-1) unstable; urgency=medium

  * New upstream release.

 -- Thomas Leonard <talex5@gmail.com>  Thu, 02 Apr 2020 19:55:56 +0000

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,11 @@
 Priority: optional
 Maintainer: Thomas Leonard <talex5@gmail.com>
 Build-Depends: binutils,
-               cppo,
                debhelper (>= 9),
                dh-ocaml,
-               gettext,
                gnupg,
                libcurl-ocaml-dev,
-               liblablgtk2-ocaml-dev,
+               liblablgtk3-ocaml-dev,
                liblwt-ocaml-dev (>= 2.7.0),
                libounit-ocaml-dev,
                libsha-ocaml-dev,
@@ -17,7 +15,6 @@
                libyojson-ocaml-dev,
                libppxlib-ocaml-dev,
                liblwt-log-ocaml-dev,
-               menhir,
                ocaml-dune,
                ocaml-findlib,
                ocaml-nox,
@@ -32,7 +29,7 @@
 Package: 0install
 Architecture: any
 Depends: 0install-core (>= ${source:Version}),
-         libgtk2.0-0,
+         libgtk-3-0,
          ${misc:Depends},
          ${shlibs:Depends}
 Replaces: 0install-core (<< 2.10-1)

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/0install-v(\d\S+)\.tbz/zeroinstall-injector_$1\.tbz/,\
versionmangle=s/0install-v(\d\S)/$1/,\
pgpsigurlmangle=s/\/0install-v(\d\S+)\.tbz/\/0install-v$1\.tbz\.sig/ \
  https://github.com/0install/0install/releases .*/v?(\d\S+)\.tbz

## zeroinstall-injector 2.18

=== Makefile ===
--- 
+++ 
@@ -4,6 +4,9 @@
 
 # Using PROFILE=dev makes warnings fatal and makes the build faster by doing fewer optimisations
 PROFILE ?= release
+
+# Only build the 0install-gtk GUI package if lablgtk3 is available.
+PACKAGES = 0install,0install-solver$(shell ocamlfind query -format ,0install-gtk lablgtk3 2> /dev/null)
 
 # There are several things you might want to do:
 #
@@ -41,7 +44,7 @@
 VERSION = $(shell sed -n 's/let version = "\(.*\)"/\1/p' ${SRCDIR}/src/zeroinstall/about.ml)
 
 all:
-	dune build --root=. --profile=${PROFILE} @install
+	dune build --root=. --profile=${PROFILE} --only-packages=${PACKAGES} @install
 	install -d "${DISTDIR}"
 	install -d "${DISTDIR}/files"
 	install -d "${DISTDIR}/files/gui_gtk"
@@ -62,10 +65,10 @@
 	[ -f "${DISTDIR}/0install/build-environment.xml" ] || sed 's/@ARCH@/${OS}-${MACHINE}/;s/@VERSION@/${VERSION}/' "${SRCDIR}/binary-feed.xml.in" > "${DISTDIR}/0install/feed.xml"
 
 test:
-	dune runtest --root=. --profile=${PROFILE}
+	dune runtest --root=. --profile=${PROFILE} --only-packages=${PACKAGES}
 
 doc:
-	dune build --root=. --profile=${PROFILE} @doc
+	dune build --root=. --profile=${PROFILE} --only-packages=${PACKAGES} @doc
 
 install: install_local
 
@@ -92,4 +95,4 @@
 	docker build -f $< ./static -t 0install-test
 	docker run --rm -it -v "${SRCDIR}/static:/mnt:ro" 0install-test /mnt/run-tests.sh
 
-static-test: static-test-debian-10 static-test-fedora-30
+static-test: static-test-debian-11 static-test-fedora-36

=== src/Makefile ===
# Running make from this directory builds with the "dev" profile rather than the "release" one.
# To build and run a custom command manually, use e.g.:
#
#   dune exec 0install -- -help

default: test

all:
	make -C .. PROFILE=dev all

test:
	make -C .. PROFILE=dev test

doc:
	make -C .. PROFILE=dev doc

clean:
	make -C .. PROFILE=dev clean

=== debian/changelog ===
zeroinstall-injector (2.18-2ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:47:59 +1100

zeroinstall-injector (2.18-2ubuntu1) noble; urgency=medium

  * Don't hard-code shared library dependency. ${shlibs:Depends} is
    working these days.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 23 Mar 2024 16:16:34 +0100

zeroinstall-injector (2.18-2build5) noble; urgency=medium

  * No-change rebuild against libgtk-3-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 19 Mar 2024 06:17:33 +0000

zeroinstall-injector (2.18-2build4) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 07:37:08 +0000

zeroinstall-injector (2.18-2build3) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 08:21:33 +0000

zeroinstall-injector (2.18-2build2) lunar; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 03 Dec 2022 21:29:20 +0100

zeroinstall-injector (2.18-2build1) lunar; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 27 Nov 2022 08:39:26 +0100

zeroinstall-injector (2.18-2) unstable; urgency=medium

  * Fix build on bytecode-only platforms. Closes: #1022235.

 -- Thomas Leonard <talex5@gmail.com>  Mon, 24 Oct 2022 13:25:32 +0000

zeroinstall-injector (2.18-1) unstable; urgency=medium

  * New upstream release.

 -- Thomas Leonard <talex5@gmail.com>  Sun, 21 Aug 2022 12:25:23 +0000

zeroinstall-injector (2.16-2) unstable; urgency=medium

  * Make compiler warnings non-fatal. Closes: #1002272, #1002635.

 -- Thomas Leonard <talex5@gmail.com>  Thu, 30 Dec 2021 12:01:23 +0000

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,11 @@
 Source: zeroinstall-injector
 Section: admin
 Priority: optional
-Maintainer: Thomas Leonard <talex5@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Thomas Leonard <talex5@gmail.com>
 Build-Depends: binutils,
-               debhelper (>= 9),
+               debhelper (>= 13),
+               debhelper-compat (= 13),
                dh-ocaml,
                gnupg,
                libcurl-ocaml-dev,
@@ -21,7 +23,7 @@
                ocamlbuild,
                tzdata,
                unzip
-Standards-Version: 4.4.0
+Standards-Version: 4.6.1
 Homepage: http://0install.net/
 Vcs-Browser: https://github.com/0install/0install-debian
 Vcs-Git: https://github.com/0install/0install-debian.git
@@ -29,7 +31,6 @@
 Package: 0install
 Architecture: any
 Depends: 0install-core (>= ${source:Version}),
-         libgtk-3-0,
          ${misc:Depends},
          ${shlibs:Depends}
 Replaces: 0install-core (<< 2.10-1)

=== debian/rules ===
--- 
+++ 
@@ -18,7 +18,7 @@
 
 build-stamp:
 	dh_testdir
-	mv vendor/lwt_glib-1.1.1 . && dune build @lwt_glib-1.1.1/install && dune install --prefix=$(VENDOR) lwt_glib && rm -rf lwt_glib-1.1.1
+	mv vendor/lwt_glib-1.1.1 . && dune build --release @lwt_glib-1.1.1/install && dune install --release --prefix=$(VENDOR) lwt_glib && rm -rf lwt_glib-1.1.1
 	if [ -x /usr/bin/ocamlopt ]; then \
 		make OCAMLPATH=$(OCAMLPATH) TYPE=native; \
 	else \
